1000 REM used with a predominance plot, e.g. added to 'carry' section of ht1.inc etc to write 'carry' variables to a spreadsheet etc
1010 REM gives output to the PHREEQC print output (PRINT) as well as to the selected output (PUNCH)
1020 REM spreadsheet output in trk file but check that the 'NumberOfSpecies' output remains constant
1030 REM input: <mainspecies>
1040 REM output: summary of speciation PRINT'ed (phreeqc.0.out and phreeqcall.out) and PUNCH'ed ( *.out and *.trk)
1050 maxspecies = 100
1060 PUNCH "sim_no", SIM_NO, "pH", -LA("H+"), "pe", -LA("e-")
1070 PUNCH "mu", MU, "charge_balance", CHARGE_BALANCE, "percent_error", PERCENT_ERROR
1080 npunch = 6
1090 REM some total dissolved and species concs
1100 el$ = "<mainspecies>"
1110 padlength = 30
1120 REM
1130 h2o = TOT("water")
1140 REM
1150 PRINT
1160 PRINT "----------------------------------User print-----------------------------------"
1170 PRINT
1180 REM
1190 REM List System totals and dissolved totals over all valence states
1200 PRINT TRIM(el$)
1210 PRINT "System    ", SYS(el$), "mol"
1220 PRINT "Dissolved ", TOT(el$)*h2o, "mol"
1230 PRINT "Wt water  ", h2o, "kg"
1240 PUNCH el$+"T(mol)", SYS(el$), el$+"diss(mol)", TOT(el$)*h2o, "water(kg)", h2o
1250 npunch = npunch+3
1260 DIM indx(maxspecies)
1270 REM List system total and dissolved totals for all species in redox states -4 to +7
1280 k1 = -4
1290 k2 = 7
1300 totspecies = 0
1310 nv = 0
1320 REM add bare el$ at end for when no secondary species
1330 FOR k = k1 TO k2+1
1340    sms$ = TRIM(el$)+"("+TRIM(STR$(k))+")"
1350    if (k<=k2) THEN 1380
1360    sms$ = el$
1370    if (nv>0) THEN 1730   
1380    elt = SYS(sms$, ns, ns$, ts$, moles)
1390    REM Output all species to keep trk file in sync (for el(...), SYS() and TOT()*h2o are the same)
1400    REM PUNCH sms$+"T(mol/kgw)", elt/h2o
1401    PUNCH sms$+"diss(mol/kgw)", TOT(sms$)
1410    npunch = npunch+1
1420    np = 0
1430    IF(elt <= 0) THEN 1510
1440    PRINT
1450    PRINT TRIM(sms$)
1460    PRINT "System   ", elt, "mol"  # includes solids etc
1470    PRINT "Dissolved", TOT(sms$)*h2o, "mol"
1480    PRINT
1490    nv = nv + 1
1500    REM
1510    IF(ns > maxspecies) THEN ns = maxspecies
1520    REM sort by species name
1530    REM ... and return places in indx()
1540    GOSUB 20000
1550    FOR j = 1 TO ns
1560       ix = indx(j)
1570       c = moles(ix)/h2o
1580       IF(ts$(ix) = "equi") THEN c = EQUI(ns$(j))/h2o ELSE 1600
1590       GOTO 1700  # omit output since valence is that of RHS not necessarily of phase
1600       IF(ts$(ix) = "aq") THEN c = MOL(ns$(j)) ELSE 1620
1610       GOTO 1630
1620       IF(ts$(ix) = "gas") THEN c = GAS(ns$(j))/h2o
1630       IF(np = 1 OR c = 0) THEN 1670
1640       PRINT "Species                        type          mol element             mol species/kgw"
1650       np = np + 1
1660       REM PAD for alignment of low and high precision output
1670       IF(c > 0) THEN PRINT PAD(ns$(j), padlength), PAD(ts$(ix), 10), PAD(STR$(moles(ix)), 23), PAD(STR$(c), 20)
1680       PUNCH ns$(j), c
1690       npunch = npunch+1
1700    NEXT j
1710 REM
1720    totspecies = totspecies+ns
1730 NEXT k
1740 PRINT
1750 PRINT "Pure phases"
1760 PRINT
1770 REM
1780 REM now pure phases (solids and gases)...
1790 REM moles of all phases containing el$
1800 pt = SYS("phases", ns, ns$, tp$, sis)
1810 GOSUB 20000  # sort
1820 f$ = ""
1830 k = 0
1840 FOR i = 1 TO ns
1850    p$ = ns$(i)
1860    ix = indx(i)
1870    f$ = phase_formula(p$) # PHREEQC3
1880    IF(INSTR(f$, el$) = 0) THEN 1970  # PHREEQC3
1890    IF(INSTR(p$, "(g)") > 0) THEN tp$(ix) = "gas" ELSE tp$(ix) = "solid"
1900    a = EQUI(p$)
1910    IF (k=0) THEN PRINT "Phase                          type               SI                     mol            Formula"
1920    PRINT PAD(p$, padlength), PAD(tp$(ix), 10), PAD(STR$(sis(ix)), 23), PAD(STR$(a), 20), PAD("", 0), f$
1930    PUNCH "SI_"+ p$, sis(ix), p$, a
1940    npunch = npunch+2
1950    totspecies = totspecies+1
1960    k = k + 1
1970  NEXT i
1980 PUNCH "NumberOfspecies", totspecies   # must be constant for trk file to be correct
1981 npunch = npunch+1
1982 PRINT
1990 RETURN

include sortindx.inc
